/* A SIMPLE PROGRAM FOR A BINARY TREE BUILDING AND THEN TRAVERSING IT IN  */
	   /* PREORDER INORDER OR POSTORDER FORM  */

#include<stdio.h>
#include<conio.h>
#include<alloc.h>
#include<string.h>


#define TRUE 1
#define FALSE 0
#define NULL 0
#define MAXLEN 80

	struct btree
	 {
	  char info ;
	  struct btree *left;
	  struct btree *right;
	 };
	typedef struct btree* BTREE;
	BTREE root=NULL;

void getexpression(char *);
void buildtree(char *);
BTREE maketree(char c);
BTREE setleft(BTREE t,char c);
BTREE setright(BTREE t,char c);

void _freeroutine();
void preordertraversal(BTREE t);
void inordertraversal(BTREE t);
void postordertraversal(BTREE t);

void main()
{
 char choice;
 static char str[MAXLEN];

 clrscr();
 printf("\n First we will build the tree");
 getexpression(str); // get the expression in the string pointed to by strs

 buildtree(str);

 clrscr();
 printf("\n**********************  MENU  ******************************\n");
 printf("\nPress \"P\" for preorder traversal");
 printf("\nPress \"I\" for inorder traversal");
 printf("\nPress \"O\" for postorder traversal");
 printf("\n************************************************************\n");

 fflush(stdin);
 choice=getch();

 switch(choice)
  {
    case 'I':
	      printf("\nTree traversed inorder is as follows...\n");
	      inordertraversal(root);
	      getch();
	      break;

    case 'P':
	      printf("\nTree traversed preorder is as follows...\n");
	      preordertraversal(root);
	      getch();
	      break;

    case 'O':
	      printf("\nTree traversed postorder is as follows...\n");
	      postordertraversal(root);
	      getch();
	      break;
  }
 //_freeroutine();
 getch();
}

void getexpression(char *s)
{
 int i;
 clrscr();
 printf("\n Enter the expression...\n");
 fgets(s,MAXLEN,stdin);
 i=strlen(s);
 s[i-1]='\0';		//overwrite the newline character
}

void buildtree(char *s)
{
  int i=1;
  BTREE p=NULL,q=NULL;

  root=maketree(s[0]);
  p=q=root;

	while(s[i]!='\0')
	 {
	   p=q=root;

		while(s[i]!=p->info && q!=NULL)
		 {
		   if (s[i]<p->info) q=q->left;
		    else q=q->right;

		   //p=q;
		 }

	   if(s[i]<p->info) setleft(p,s[i]);
	    else setright(p,s[i]);

	   i++;
	 }
}


BTREE maketree(char c)
{
 BTREE t=NULL;
 t=(BTREE)malloc(sizeof(struct btree));

	if(t==NULL)
	 {
	   printf("\n NOT ENOUGH MEMORY AVAILABLE");
	   getch();
	   exit(0);
	 }
	else
	 {
	   t->info=c;
	   t->left=NULL;
	   t->right=NULL;
	 }
 return(t);
}

BTREE setleft(BTREE tg,char c)
{
 BTREE t=NULL;

 if(tg->left!=NULL)
  {
    printf("\nINVALID INSERTION!\n");
    getch();
    //_freeroutine();
    exit(0);
  }
 else
  {
    t=(BTREE)malloc(sizeof(struct btree));

	if(t==NULL)
	 {
	   printf("\n NOT ENOUGH MEMORY AVAILABLE");
	   getch();
	   exit(0);
	 }
	else
	 {
	   t->info=c;
	   tg->left=t;
	   t->left=NULL;
	   t->right=NULL;
	 }
  }
 return(t);
}

BTREE setright(BTREE tg,char c)
{
 BTREE t=NULL;

 if(tg->right!=NULL)
  {
    printf("\nINVALID INSERTION!\n");
    getch();
    //_freeroutine();
    exit(0);
  }
 else
  {
    t=(BTREE)malloc(sizeof(struct btree));

	if(t==NULL)
	 {
	   printf("\n NOT ENOUGH MEMORY AVAILABLE");
	   getch();
	   exit(0);
	 }
	else
	 {
	   t->info=c;
	   tg->right=t;
	   t->left=NULL;
	   t->right=NULL;
	 }
  }
 return(t);
}


void inordertraversal(BTREE t)
{
 if (t!=NULL);
  {
    inordertraversal(t->left);
    printf("%c",t->info);
    inordertraversal(t->right);
  }
}

void preordertraversal(BTREE t)
{
 if (t!=NULL);
  {
    printf("%c",t->info);
    preordertraversal(t->left);
    preordertraversal(t->right);
  }
}

void postordertraversal(BTREE t)
{
 if (t!=NULL);
  {
    postordertraversal(t->left);
    preordertraversal(t->right);
    printf("%c",t->info);
  }
}

/*void _freeroutine(BTREE t);
{
 BTREE t;
 t=root;

	while(t->left!=NULL) t=t->left;*/